//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit2.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(&UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall TWorkThread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall TWorkThread::TWorkThread(
									HWND p_hWindowHandle,
									TMainQueu* p_TMainQueuPtr,
									bool CreateSuspended
									)
	: TThread(CreateSuspended)
{
	FWindowHandle=p_hWindowHandle;
	FMainQueu=p_TMainQueuPtr;
	::InitializeCriticalSection(&FLock);
	FTerminateEvent=::CreateEventW(NULL,0,0,NULL);
	FQueuEvent=::CreateEventW(NULL,0,0,NULL);
	FQueuList=new TList;
}
__fastcall TWorkThread::~TWorkThread(void)
{
	this->Terminate();
	::SetEvent(FTerminateEvent);
	::WaitForSingleObject(HANDLE(Handle),-1);
//	this->WaitFor();
	// need clear queu data first

	delete FQueuList;
	FQueuList=NULL;
	::CloseHandle(FTerminateEvent);
	::CloseHandle(FQueuEvent);
	::DeleteCriticalSection(&FLock);
}
void TWorkThread::GetDatas(TList* p_DataListPtr)
{
	INT t_iDataCount=0;
	__try
	{
		::EnterCriticalSection(&FLock);
		__try
		{
			do
			{
				if(NULL==p_DataListPtr)
					break;
				t_iDataCount=FQueuList->Count;
				if(0>=t_iDataCount)
					break;
				for(INT i=0;i<t_iDataCount;i++)
					p_DataListPtr->Add(FQueuList->Items[i]);
			}while(0);
		}
		__finally
		{
			FQueuList->Clear();
			::LeaveCriticalSection(&FLock);
        }
	}
	__except(1)
	{

	}

}
//---------------------------------------------------------------------------
void __fastcall TWorkThread::Execute()
{
	HANDLE t_Handles[2]={FTerminateEvent,FQueuEvent};
	::TList* t_DataListPtr=new TList();
	INT t_iDataCount=0;
	while(!Terminated)
		__try
		{
			__try
			{
				do
				{
					if((WAIT_OBJECT_0+1)!=::WaitForMultipleObjects(2,t_Handles,0,INFINITE))
						break;
					GetDatas(t_DataListPtr);
					if(NULL==t_DataListPtr)
						break;
					//do something
					//
					t_iDataCount=t_DataListPtr->Count;
					for(INT i=0;i<t_iDataCount;i++)
						FMainQueu->PutData(t_DataListPtr->Items[i]);
					::PostMessage(FWindowHandle,WM_USER+1,0,0);
				}while(0);
			}
			__finally
			{
				if(NULL!=t_DataListPtr)
					t_DataListPtr->Clear();

			}
		}
		__except(1)
		{

		}
	delete t_DataListPtr;

}
//---------------------------------------------------------------------------
void TWorkThread::PutData(PVOID p_DataPtr)
{
	__try
	{
		::EnterCriticalSection(&FLock);
		__try
		{
			do
			{
				if(Terminated)
					break;
				FQueuList->Add(p_DataPtr);
				::SetEvent(FQueuEvent);
			}while(0);
		}
		__finally
		{
			::LeaveCriticalSection(&FLock);
		}
	}
	__except(1)
	{

	}
}
